{ 030125e4a.pas                                                             }
{ 2003-01-25 programmeerimisolmpiaadi edasijudnute 4. lesande lahendus   }
{    MAATRIKSID                                                             }
{ Kirsto Tammeoja                                                           }
{ Testitud: FPC 1.0.6/GO32V2, TPC 7.0                                       }

CONST
 sis_fail = 'MAATR.SIS';
 val_fail = 'MAATR.VAL';

TYPE
 t_maatriks = ARRAY [1..10, 1..10] OF Char;
 t_poore = RECORD {prde tulemus ja kuidas see saavutatud on}
  mat : t_maatriks;
  samme : Integer;
  tee : String;
 END;

VAR
 sfail, vfail : Text;

 k, l : Integer;
 N : integer;
 maatr_1, maatr_2 : t_maatriks;

 pooratud_mat : t_maatriks;

 poorded : ARRAY [1..8] OF t_poore;
 poorded_l : Integer; {viimane indeks, kus mingi maatriks kirjas}

 leiti_vastus : Boolean;


PROCEDURE kirjuta_jah (tee : String);
BEGIN
 WriteLn (vfail, 'JAH');
 WriteLn (vfail, Length (tee));
 WriteLn (vfail, tee);
END; {kirjuta_jah}


PROCEDURE kirjuta_ei;
BEGIN
 WriteLn (vfail, 'EI');
END; {kirjuta_ei}


{--------- MAATRIKSITEGA TEGELEMISEKS ----------}

PROCEDURE poora_90 (VAR tulemus, algne : t_maatriks);
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO N DO
  FOR l := 1 TO N DO
   tulemus[l, (N+1)-k] := algne[k, l];
END; {poora_90}


PROCEDURE peegelda_V (VAR tulemus, algne : t_maatriks);
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO N DO
  FOR l := 1 TO N DO
   tulemus[k, (N+1) - l] := algne[k, l];
END; {peegelda_V}


FUNCTION on_vordsed (VAR mat1, mat2 : t_maatriks) : Boolean;
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO N DO
  FOR l := 1 TO N DO
   IF mat1[k, l]<>mat2[k, l] THEN BEGIN
    on_vordsed := FALSE;
    EXIT;
   END;

 on_vordsed := TRUE;
END; {on_vordsed}


{-------- PRETE MASSIIVIGA TEGELEMISEKS ---------}

{Tagastab TRUE, kui selline pre on juba leitud.
 0-nda indeksiga pre on tegelikult lihtsalt mugavuse prast
 ning seetottu temaga ei arvestata}
FUNCTION leidub_poore (VAR mat : t_maatriks) : Boolean;
VAR l : Integer;
BEGIN
 FOR l := 1 TO poorded_l DO
  IF on_vordsed (mat, poorded[l].mat) THEN BEGIN
   leidub_poore := TRUE;
   EXIT;
  END;

 leidub_poore := FALSE;
END; {leidub_poore}


{Lisa uue prde prete massiivi}
PROCEDURE lisa_poore (VAR mat : t_maatriks;
                      samme : Integer;
                      tee : String);
BEGIN
 Inc (poorded_l);

 poorded[poorded_l].mat   := mat;
 poorded[poorded_l].samme := samme;
 poorded[poorded_l].tee   := tee;
END; {lisa_poore}


{============= POHIPROGRAMM ===============}

BEGIN
 {----- andmete lugemine -----}
 Assign (sfail, sis_fail);
 Reset (sfail);

 ReadLn (sfail, N);

 {esimene maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_1[k, l]);
  ReadLn (sfail);
 END;

 {teine maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_2[k, l]);
  ReadLn (sfail);
 END;

 Close (sfail);


 {----- genereerime esimesest maatriksist koik prded -----}

 poorded_l := 0;
 lisa_poore (maatr_1, 0, '');

 l := 1; {millist maatriksit hakkame edasi prama}

 WHILE l <= poorded_l DO BEGIN {kui sellise indeksiga pre on olemas}
  {90 kraadi vorra prates}
  poora_90 (pooratud_mat, poorded[l].mat);
  IF NOT leidub_poore (pooratud_mat) THEN
   lisa_poore (pooratud_mat, poorded[l].samme+1, poorded[l].tee+'P');

  {vertikaaltelje suhtes peegeldatud}
  peegelda_V (pooratud_mat, poorded[l].mat);
  IF NOT leidub_poore (pooratud_mat) THEN
   lisa_poore (pooratud_mat, poorded[l].samme+1, poorded[l].tee+'V');

  Inc (l); {jrgmine pre, mida ttlema hakatakse}
 END;


 {----- vastuse kirjutamine -----}
 Assign (vfail, val_fail);
 Rewrite (vfail);

 leiti_vastus := FALSE;

 FOR l := 1 TO poorded_l DO
  IF on_vordsed (poorded[l].mat, maatr_2) THEN BEGIN
   leiti_vastus := TRUE;
   kirjuta_jah (poorded[l].tee);
   BREAK;
  END;

 {kui ei ole voimalik saada teist maatriksit}
 IF NOT leiti_vastus THEN kirjuta_ei;

 Close (vfail);
END.
