{ 030125e4c.pas                                                             }
{ 2003-01-25 programmeerimisolmpiaadi edasijudnute 4. lesande lahendus   }
{    MAATRIKSID                                                             }
{ Kirsto Tammeoja                                                           }
{ Testitud: FPC 1.0.6/GO32V2, TPC 7.0                                       }

CONST
 sis_fail = 'MAATR.SIS';
 val_fail = 'MAATR.VAL';

TYPE
 t_maatriks = ARRAY [1..10, 1..10] OF Char;
 t_koordinaadid = ARRAY [1..3] OF Integer;
 t_teisendus = ARRAY [1..3, 1..3] OF Integer;
 t_poore = RECORD {prde tulemus (teisendusena) ja kuidas see saavutatud on}
  teisendus : t_teisendus;
  samme : Integer;
  tee : String;
 END;

VAR
 sfail, vfail : Text;

 k, l : Integer;
 N : integer;
 maatr_1, maatr_2 : t_maatriks;

 { vastavad teisendused antud suurusega maatriksite jaoks }
 poore_90, peegeldus_V : t_teisendus;
 uus_teisendus : t_teisendus; { abiks koigi teisenduste genereerimisel }

 poorded : ARRAY [1..8] OF t_poore;
 poorded_l : Integer; {viimane indeks, kus mingi maatriks kirjas}

 leiti_vastus : Boolean;


PROCEDURE kirjuta_jah (tee : String);
BEGIN
 WriteLn (vfail, 'JAH');
 WriteLn (vfail, Length (tee));
 WriteLn (vfail, tee);
END; {kirjuta_jah}


PROCEDURE kirjuta_ei;
BEGIN
 WriteLn (vfail, 'EI');
END; {kirjuta_ei}


{--------- TEISENDUSTEGA TEGELEMISEKS -----------}

{Annab samasusteisenduse}
PROCEDURE anna_samasusteisendus (VAR teisendus : t_teisendus);
BEGIN
 teisendus[1, 1] := 1;
 teisendus[1, 2] := 0;
 teisendus[1, 3] := 0;

 teisendus[2, 1] := 0;
 teisendus[2, 2] := 1;
 teisendus[2, 3] := 0;

 teisendus[3, 1] := 0;
 teisendus[3, 2] := 0;
 teisendus[3, 3] := 1;
END; {anna_samasusteisendus}


{Annab teisenduse, mis vastab 90 kraadi vorra keeramisele}
PROCEDURE anna_poore_90 (VAR teisendus : t_teisendus);
BEGIN
 teisendus[1, 1] := 0;
 teisendus[1, 2] := 1;
 teisendus[1, 3] := 0;

 teisendus[2, 1] := -1;
 teisendus[2, 2] := 0;
 teisendus[2, 3] := N+1;

 teisendus[3, 1] := 0;
 teisendus[3, 2] := 0;
 teisendus[3, 3] := 1;
END; {anna_poore_90}


PROCEDURE anna_peegeldus_V (VAR teisendus : t_teisendus);
BEGIN
 teisendus[1, 1] := 1;
 teisendus[1, 2] := 0;
 teisendus[1, 3] := 0;

 teisendus[2, 1] := 0;
 teisendus[2, 2] := -1;
 teisendus[2, 3] := N+1;

 teisendus[3, 1] := 0;
 teisendus[3, 2] := 0;
 teisendus[3, 3] := 1;
END; {anna_peegeldus_V}


{Leiab kahe teisenduse jrjest rakendamise tulemuse}
PROCEDURE korruta_teisendused (VAR tulemus, t1, t2 : t_teisendus);
VAR k, l, m, sum : Integer;
BEGIN
 FOR k := 1 TO 3 DO
  FOR l := 1 TO 3 DO BEGIN
   sum := 0;

   FOR m := 1 to 3 DO
    sum := sum + t1[k,m]*t2[m,l];

   tulemus[k, l] := sum;
  END;
END; {korruta_teisendused}


{Rakendab vastavat teisendust ette antud koordinaatidel}
PROCEDURE leia_koordinaadid (VAR tulemus, algkoord : t_koordinaadid;
                            teisendus : t_teisendus);
VAR k, m, sum : Integer;
BEGIN
 FOR k := 1 TO 3 DO BEGIN
  sum := 0;

  FOR m := 1 TO 3 DO
   sum := sum + teisendus[k, m]*algkoord[m];

  tulemus[k] := sum;
 END;
END; {leia_koordinaadid}


FUNCTION on_teis_vordsed (VAR t1, t2 : t_teisendus) : Boolean;
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO 3 DO
  FOR l := 1 TO 3 DO
   IF t1[k, l]<>t2[k, l] THEN BEGIN
    on_teis_vordsed := FALSE;
    EXIT;
   END;

 on_teis_vordsed := TRUE;
END; {on_teis_vordsed}


{--------- MAATRIKSITEGA TEGELEMISEKS ----------}

{Kas maatriksid on vordsed, kui kasutada esimesest
 teise saamiseks ette antud teisendust}
FUNCTION on_vordsed (VAR mat1, mat2 : t_maatriks;
                     teisendus : t_teisendus) : Boolean;
VAR k1, k2 : t_koordinaadid;
BEGIN
 k1[3] := 1;

 FOR k1[1] := 1 TO N DO
  FOR k1[2] := 1 TO N DO BEGIN
   leia_koordinaadid (k2, k1, teisendus);

   IF mat1[k1[1], k1[2]]<>mat2[k2[1], k2[2]] THEN BEGIN
    on_vordsed := FALSE;
    EXIT;
   END;

  END;

 on_vordsed := TRUE;
END; {on_vordsed}


{-------- PRETE MASSIIVIGA TEGELEMISEKS ---------}

{Tagastab TRUE, kui selline pre on juba leitud.
 0-nda indeksiga pre on tegelikult lihtsalt mugavuse prast
 ning seetottu temaga ei arvestata}
FUNCTION leidub_poore (VAR teisendus : t_teisendus) : Boolean;
VAR l : Integer;
BEGIN
 FOR l := 1 TO poorded_l DO
  IF on_teis_vordsed (teisendus, poorded[l].teisendus) THEN BEGIN
   leidub_poore := TRUE;
   EXIT;
  END;

 leidub_poore := FALSE;
END; {leidub_poore}


{Lisa uue prde prete massiivi}
PROCEDURE lisa_poore (VAR teisendus : t_teisendus;
                      samme : Integer;
                      tee : String);
BEGIN
 Inc (poorded_l);

 poorded[poorded_l].teisendus := teisendus;
 poorded[poorded_l].samme     := samme;
 poorded[poorded_l].tee       := tee;
END; {lisa_poore}


{============= POHIPROGRAMM ===============}

BEGIN
 {----- andmete lugemine -----}
 Assign (sfail, sis_fail);
 Reset (sfail);

 ReadLn (sfail, N);

 {esimene maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_1[k, l]);
  ReadLn (sfail);
 END;

 {teine maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_2[k, l]);
  ReadLn (sfail);
 END;

 Close (sfail);


 {----- genereerime koik voimalikud prded -----}

 {elementaarprded}
 anna_poore_90 (poore_90);
 anna_peegeldus_V (peegeldus_V);

 {prete leidmine}
 poorded_l := 0;
 anna_samasusteisendus (uus_teisendus);
 lisa_poore (uus_teisendus, 0, '');

 l := 1; {millist teisendust hakkame edasi ttlema}

 WHILE l <= poorded_l DO BEGIN {kui sellise indeksiga pre on olemas}
  {90 kraadi vorra prates}
  korruta_teisendused (uus_teisendus,
                       poore_90,
                       poorded[l].teisendus);
  IF NOT leidub_poore (uus_teisendus) THEN
   lisa_poore (uus_teisendus, poorded[l].samme+1, poorded[l].tee+'P');

  {vertikaaltelje suhtes peegeldatud}
  korruta_teisendused (uus_teisendus,
                       peegeldus_V,
                       poorded[l].teisendus);
  IF NOT leidub_poore (uus_teisendus) THEN
   lisa_poore (uus_teisendus, poorded[l].samme+1, poorded[l].tee+'V');

  Inc (l); {jrgmine pre, mida ttlema hakatakse}
 END;


 {----- vastuse kirjutamine -----}
 Assign (vfail, val_fail);
 Rewrite (vfail);

 leiti_vastus := FALSE;

 FOR l := 1 TO poorded_l DO
  IF on_vordsed (maatr_1, maatr_2, poorded[l].teisendus) THEN BEGIN
   leiti_vastus := TRUE;
   kirjuta_jah (poorded[l].tee);
   BREAK;
  END;

 {kui ei ole voimalik saada teist maatriksit}
 IF NOT leiti_vastus THEN kirjuta_ei;

 Close (vfail);
END.
