{ 030125e4d.pas                                                             }
{ 2003-01-25 programmeerimisvistluse edasijudnute 4. lesande lahendus    }
{    MAATRKISID                                                             }
{ Ahto Truu                                                                 }
{ Testitud: FPC 1.0.6/Win32, TPC 6.0                                        }

const
   sisf = 'MAATR.SIS';
   valf = 'MAATR.VAL';
   maxn = 10;

const
   maxt = 8;
   t : array [1..maxt] of string = (
      '',      { algseis }
      'P',     { pre 90 pripeva }
      'PP',    { pre 180 pripeva }
      'PPP',   { vi 'VPV', pre 270 pripeva }
      'V',     { peegeldus vertikaalteljest }
      'PPV',   { vi 'VPP', peegeldus horisontaalteljest }
      'PV',    { peegeldus peadiagonaalist }
      'VP');   { peegeldus krvaldiagonaalist }

type
   maatr = array [1..maxn, 1..maxn] of char;

{ loeb failist n*n maatriksi }
procedure loe_maatr (var f : text; var m : maatr; n : integer);
var i, j : integer;
begin
   for i := 1 to n do begin
      for j := 1 to n do
         read(f, m[i, j]);
      readln(f);
   end;
end;

{ m2 := m1 pratud 90 kraadi }
procedure maatr_p (var m1, m2 : maatr; n : integer);
var i, j : integer;
begin
   for i := 1 to n do
      for j := 1 to n do
         m2[j, n - i + 1] := m1[i, j];
end;

{ m2 := m1 peegeldatud vertikaalteljest }
procedure maatr_v (var m1, m2 : maatr; n : integer);
var i, j : integer;
begin
   for i := 1 to n do
      for j := 1 to n do
         m2[i, n - j + 1] := m1[i, j];
end;

{ kontrollib, kas m1 = m2 }
function on (var m1, m2 : maatr; n : integer) : boolean;
var i, j : integer;
begin
   on := true;
   for i := 1 to n do
      for j := 1 to n do
         if m1[i, j] <> m2[i, j] then
            on := false;
end;

{ kontrollib, kas m2 = m1 rakendatud teisendus t }
function onT (var m1, m2 : maatr; n : integer; t : string) : boolean;
var ma, mb : maatr; i : integer;
begin
   ma := m1;
   for i := 1 to length(t) do begin
      if t[i] = 'P' then
         maatr_p(ma, mb, n);
      if t[i] = 'V' then
         maatr_v(ma, mb, n);
      ma := mb;
   end;
   onT := on(ma, m2, n);
end;

var
   f : text;                                           { sisend/vljundfail }
   n : integer;                                        { maatriksite suurus }
   m1, m2 : maatr;                                             { maatriksid }
   oli : boolean;
   i : integer;

begin
   assign(f, sisf); reset(f);
   readln(f, n);
   loe_maatr(f, m1, n);
   loe_maatr(f, m2, n);
   close(f);

   assign(f, valf); rewrite(f);
   oli := false;
   for i := 1 to maxt do
      if not oli and onT(m1, m2, n, t[i]) then begin
         writeln(f, 'JAH');
         writeln(f, length(t[i]));
         writeln(f, t[i]);
         oli := true;
      end;
   if not oli then
      writeln(f, 'EI');
   close(f);
end.
