PROGRAM maatr;

USES
 SysUtils;

TYPE
 t_maatriks = ARRAY [1..10, 1..10] OF Char;
 t_poore = RECORD {prde tulemus ja kuidas see saavutatud on}
  mat : t_maatriks;
  samme : Integer;
  tee : String[8];
 END;

VAR
 sfail : Text;

 k, l : Integer;
 N : integer;
 maatr_1, maatr_2 : t_maatriks;

 pooratud_mat : t_maatriks;

 poorded : ARRAY [1..8] OF t_poore;
 poorded_l : Integer; {viimane indeks, kus mingi maatriks kirjas}

 leiti_vastus : Boolean;

 //kontrollimiseks
 rida1, rida3, tekst : String;
 vastus_oige, sai_loetud : Boolean;
 loeti_r3 : Boolean;

 vastus_samme : Integer;
 vastus_sis   : Integer;

 mat, mata : t_maatriks;


{--------- MAATRIKSITEGA TEGELEMISEKS ----------}

PROCEDURE poora_90 (VAR tulemus, algne : t_maatriks);
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO N DO
  FOR l := 1 TO N DO
   tulemus[l, (N+1)-k] := algne[k, l];
END; {poora_90}


PROCEDURE peegelda_V (VAR tulemus, algne : t_maatriks);
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO N DO
  FOR l := 1 TO N DO
   tulemus[k, (N+1) - l] := algne[k, l];
END; {peegelda_V}


FUNCTION on_vordsed (VAR mat1, mat2 : t_maatriks) : Boolean;
VAR k, l : Integer;
BEGIN
 FOR k := 1 TO N DO
  FOR l := 1 TO N DO
   IF mat1[k, l]<>mat2[k, l] THEN BEGIN
    on_vordsed := FALSE;
    EXIT;
   END;

 on_vordsed := TRUE;
END; {on_vordsed}


{-------- PRETE MASSIIVIGA TEGELEMISEKS ---------}

{Tagastab TRUE, kui selline pre on juba leitud.
 0-nda indeksiga pre on tegelikult lihtsalt mugavuse prast
 ning seetottu temaga ei arvestata}
FUNCTION leidub_poore (VAR mat : t_maatriks) : Boolean;
VAR l : Integer;
BEGIN
 FOR l := 1 TO poorded_l DO
  IF on_vordsed (mat, poorded[l].mat) THEN BEGIN
   leidub_poore := TRUE;
   EXIT;
  END;

 leidub_poore := FALSE;
END; {leidub_poore}


{Lisa uue prde prete massiivi}
PROCEDURE lisa_poore (VAR mat : t_maatriks;
                      samme : Integer;
                      tee : String[8]);
BEGIN
 Inc (poorded_l);

 poorded[poorded_l].mat   := mat;
 poorded[poorded_l].samme := samme;
 poorded[poorded_l].tee   := tee;
END; {lisa_poore}


{============= POHIPROGRAMM ===============}

BEGIN
 IF ParamCount<2 THEN BEGIN
  WriteLn ('Sntaks on: ',ParamStr (0),' sisendfail valjundfail');
  Halt (1);
 END;

 {----- andmete lugemine -----}
 WriteLn ('Sisendandmete lugemine...');

 Assign (sfail, ParamStr (1));
 Reset (sfail);

 ReadLn (sfail, N);

 {esimene maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_1[k, l]);
  ReadLn (sfail);
 END;

 {teine maatriks}
 FOR k := 1 TO N DO BEGIN
  FOR l := 1 TO N DO
   Read (sfail, maatr_2[k, l]);
  ReadLn (sfail);
 END;

 Close (sfail);


 {----- genereerime esimesest maatriksist koik prded -----}

 poorded_l := 0;
 lisa_poore (maatr_1, 0, '');

 l := 1; {millist maatriksit hakkame edasi prama}

 WHILE l <= poorded_l DO BEGIN {kui sellise indeksiga pre on olemas}
  {90 kraadi vorra prates}
  poora_90 (pooratud_mat, poorded[l].mat);
  IF NOT leidub_poore (pooratud_mat) THEN
   lisa_poore (pooratud_mat, poorded[l].samme+1, poorded[l].tee+'P');

  {vertikaaltelje suhtes peegeldatud}
  peegelda_V (pooratud_mat, poorded[l].mat);
  IF NOT leidub_poore (pooratud_mat) THEN
   lisa_poore (pooratud_mat, poorded[l].samme+1, poorded[l].tee+'V');

  Inc (l); {jrgmine pre, mida ttlema hakatakse}
 END;


 {----- vastuse leidmine -----}
 leiti_vastus := FALSE;

 FOR l := 1 TO poorded_l DO
  IF on_vordsed (poorded[l].mat, maatr_2) THEN BEGIN
   leiti_vastus := TRUE;
   vastus_samme := poorded[l].samme;
   BREAK;
  END;

 {kui ei ole voimalik saada teist maatriksit}
 IF NOT leiti_vastus THEN vastus_samme := -1;



 {----- vljundi lugemine -----}
 WriteLn ('Vljundi lugemine...');
 WriteLn;

 Assign (sfail, ParamStr (2));
 Reset (sfail);

 Readln (sfail, rida1);

 {vastuse kontroll}
 sai_loetud := TRUE;
 loeti_r3 := FALSE;

 IF UpperCase (Trim (rida1)) = 'EI' THEN BEGIN
  vastus_sis := -1;
  vastus_oige := vastus_samme<0;
 END ELSE BEGIN
  ReadLn (sfail, vastus_sis);
  ReadLn (sfail, rida3);
  loeti_r3 := TRUE;
  tekst := UpperCase (Trim (rida3));

  IF vastus_sis = vastus_samme THEN BEGIN
   mat := maatr_1;

   IF Length (tekst) < vastus_sis THEN BEGIN
    sai_loetud := FALSE; vastus_oige := FALSE;
   END;

   IF sai_loetud THEN BEGIN
    FOR l := 1 TO vastus_sis DO BEGIN
     CASE tekst[l] OF
      'P': BEGIN
            poora_90 (mata, mat);
            mat := mata;
           END;
      'V': BEGIN
            peegelda_V (mata, mat);
            mat := mata;
           END;
      ELSE
       sai_loetud := FALSE;
      END; //case

    END; //for
   END; //if

   IF sai_loetud THEN BEGIN
    vastus_oige := on_vordsed (mat, maatr_2);
   END;

  END ELSE
   vastus_oige := FALSE;
 END;

 {tulemuse kirjutamine}
 IF sai_loetud THEN BEGIN
  IF vastus_oige THEN WriteLn ('OK')
  ELSE BEGIN
   WriteLn ('Vastus vale');
   IF vastus_sis = vastus_samme THEN WriteLn ('Sammude arv oige');
  END;

  WriteLn;

  {kujundusega seotu}
  IF UpperCase (Trim (rida1)) <> rida1 THEN
   WriteLn ('Vljundrida #1: ''',rida1,'''');
  IF     loeti_r3
     AND (UpperCase (Trim (rida3)) <> rida3) THEN
   WriteLn ('Vljundrida #3: ''',rida3,'''');
  IF NOT Eof (sfail) THEN BEGIN
   WriteLn ('Vljundfail pole loppenud');
  END;
 END ELSE BEGIN
  WriteLn ('Vljundformaat vale:');
  Writeln ('''',rida1,'''');
  Writeln ('''',vastus_sis,'...''');
  IF loeti_r3 THEN Writeln ('''',rida3,'''');
  WriteLn;
 END;


 Close (sfail);
END.
